-- SPDX-License-Identifier: GPL-2.0
-- Copyright (C) 2021 Jakub Horak
function decode(template, map)
	local num = 0
	assert(#template == #map)
	for ia, sa in ipairs(template) do
		for ib = 1, #sa do
			local c = sa:sub(ib, ib)
			if c:match('%d') then
				local m = map[ia]:sub(ib, ib)
				if m ~= '' and m ~= ' ' and m ~= '\t' then
					num = num + (1 << tonumber(c))
				end
			end
		end
	end
	return num
end

local template = {}
local template_done = false
local data = {}
local chartab = {}
for line in io.lines() do
	if not template_done and line:match('%d') then
		table.insert(template, line)
	else
		template_done = true
		table.insert(data, line)
		if #data == #template + 1 then
			local chars = data[1]
			table.remove(data, 1)
			local hex = decode(template, data)
			for i = 1, #chars do
				chartab[string.byte(chars:sub(i, i))] = hex
			end
			data = {}
		end
	end
end

for i = 0x20, 0x7f do
	io.write(string.format("0x%02x, ", chartab[i] or 0))
	if (i + 1) % 16 == 0 then
		print()
	end
end
