// SPDX-License-Identifier: GPL-2.0
// Copyright (C) 2021 Jakub Horak

static inline void
scan_but(byte *hist, byte state)
{
	byte x = *hist;
	x <<= 1;
	if (state)
		x |= 1;
	*hist = x;
}

static inline char
decode_enc(byte a, byte b)
{
	if ((a == 0x80) && (b & 0xf0) == 0)
		return 1;
	if ((b == 0x80) && (a & 0xf0) == 0)
		return -1;
	return 0;
}

static void
adjust(byte *px, int8_t d, byte a, byte b)
{
	byte x = *px;
	if (x <= a) {
		if (d < 0) {
			*px = a;
			return;
		}
	}  else if (x >= b) {
		if (d > 0) {
			*px = b;
			return;
		}
	}
	*px = x + d;
}
