// SPDX-License-Identifier: GPL-2.0
// Copyright (C) 2021 Jakub Horak

#include <avr/boot.h>

uint32_t
get_device_signature(void)
{
	return
		((uint32_t) boot_signature_byte_get(0) << 16) |
		((uint32_t) boot_signature_byte_get(2) << 8) |
		((uint32_t) boot_signature_byte_get(4));
}

void
lgt8f328p_compat(void)
{
	if (get_device_signature() == 0x0c000c) {
		CLKPR = 0x80;
		CLKPR = 0x01;
	}
}

#ifdef LGT8F328P

#define PINE	_SFR_IO8(0x0C)
#define DDRE	_SFR_IO8(0x0D)
#define PORTE	_SFR_IO8(0x0E)

void
clock_init_16mhz(void)
{
	CLKPR = 0x80;
	CLKPR = 0x01;
}

void
clock_init_32mhz(void)
{
	CLKPR = 0x80;
	CLKPR = 0x00;
}

void
dsc_enable(void)
{
#define DSCR _SFR_IO8(0x00)
	DSCR = 0x80;
}
#endif
